// SRCMD.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "..\SRDLL\SRDLL.h"
#include "XGetopt.h"

bool
GetOnOff(_TCHAR* str)
{
	if (str[0] == '1')
		return true;

	return false;
}

void usage()
{
	printf(	"Usage: cmdSR [Optiosn]\n"
			"   -V      Show firmware version.\n"
			"   -v      Verbose\n"
			"   -T 1|0  PTT On / Off\n"
			"   -f N    Set frequency N Hz\n"
			"\n"
			);
	exit(-1);
}

int _tmain(int argc, _TCHAR* argv[])
{
	int c;
	bool verbose = false;
	int major, minor;

	printf("------------------------------------------\n");
	printf("----- CMDSR ---------------- PE0FKO ------\n");

	if (srOpen(0x16C0, 0x05DC, _T(""), _T(""), _T(""), -1) == NULL)
	{
		wprintf(_T("USB Open: No device found.\n"));
		exit(-2);
	}

	while ((c = getopt(argc, argv, _T("vVT:f:"))) != EOF)
	{
		switch (c)
		{
		case _T('v'):
				verbose = true;
				break;

		case _T('V'):
			if (srGetVersion(&major, &minor))
			{
				wprintf(_T("Version: V%d.%d\n"), major, minor);
			}
			break;

		case _T('T'):
			{
				int ptt = GetOnOff(optarg);
				if (srSetPTTGetCWInp(ptt, NULL) && verbose)
				{
					wprintf(_T("Set PTT %d\n"), ptt);
				}
			}
			break;

		case _T('f'):
			{
				double freq = _wtoi(optarg) / 1e6;
				if (srSetFreq(freq, 0) && verbose)
				{
					wprintf(_T("Set frequency at %.6g MHz\n"), freq);
				}
			}
			break;

		case _T('?'):
			wprintf(_T("ERROR: illegal option %s\n"), argv[optind-1]);
			usage();
			break;

		default:
//			TRACE(_T("WARNING: no handler for option %c\n"), c);
			break;
		}
	}

	//
	// check for non-option args here
	//

	srClose();

	return 0;
}

